:root {
    --notification-color: var(--secondary-info-color);
    --notification-background: var(--primary-info-color);
}

.Notification {
    --animation-duration: 0; /* to sync CSS animation and JS callback */

    overflow: hidden;
    max-width: 100vw;
    padding: 12px 1rem;
    margin-bottom: 5px;
    position: relative;
    top: 0;
    color: var(--notification-color);
    background: var(--notification-background);

    will-change: max-height, opacity, transform, padding, margin;

    @include mobile {
        position: fixed;
        top: calc(var(--header-total-height) + 6px);
        right: 0;
    }

    @include after-mobile {
        display: inline-block;
        max-width: 550px;
        margin-bottom: 20px;
    }

    &-Text {
        margin-top: 0;
        margin-right: 40px;
        font-weight: bold;
    }

    &-Debug {
        overflow: scroll;
        max-height: 150px;
        padding: 5px;
        color: black;
        background: white;
        white-space: pre-wrap;
    }

    &-Button {
        width: 35px;
        height: 35px;
        padding: 10px;
        position: absolute;
        top: 0;
        right: 0;
        opacity: 1;
        background: none;
        font-size: 0;
        cursor: pointer;
        appearance: none;

        @include mobile {
            margin: auto;
            right: 1rem;
            bottom: 0;
        }

        &:focus {
            outline: none;
        }

        &::before,
        &::after {
            width: 2px;
            height: 15px;
            margin: auto;
            position: absolute;
            top: 0;
            right: 0;
            bottom: 0;
            left: 0;
            background-color: var(--notification-color);
            content: ' ';
        }

        &::before {
            transform: rotate(45deg);
        }

        &::after {
            transform: rotate(-45deg);
        }
    }

    &_is {
        &_opening {
            animation: fadeInLeft var(--animation-duration) cubic-bezier(0.645, 0.045, 0.355, 1) forwards;
        }

        &_closing {
            animation: fadeOutLeft var(--animation-duration) cubic-bezier(0.645, 0.045, 0.355, 1) forwards;
        }
    }

    &_type {
        &_error {
            --notification-color: var(--secondary-error-color);
            --notification-background: var(--primary-error-color);
        }

        &_success {
            --notification-color: var(--secondary-success-color);
            --notification-background: var(--primary-success-color);
        }

        &_info {
            --notification-color: var(--secondary-info-color);
            --notification-background: var(--primary-info-color);
        }
    }

    @keyframes fadeInLeft {
        from {
            transform: translateY(-300px);
            opacity: 0;
        }

        to {
            transform: translateY(0);
            opacity: 1;
        }
    }

    @keyframes fadeOutLeft {
        from {
            max-height: 100px;
            margin-bottom: 5px;
            transform: translateY(0);
            opacity: 1;

            @include mobile {
                margin-bottom: 20px;
            }
        }

        to {
            max-height: 0;
            padding: 0;
            margin: 0;
            transform: translateY(-300px);
            opacity: 0;
        }
    }
}
